const float alfa = 0.001;

//Переменные управления интервалами опроса гироприбора и интервалами управления
unsigned long dt;
unsigned long t0;
unsigned long t2;

double AcYsum;
// Длина окружности колеса 25см, 250мм
// Количество шагов на оборот - 200 (360/1.8)
// Количество микрошагов - 200*4 = 800 на оборот
// Количество срабатываний таймера для борота -3200 (1600*2) , так как шаг состоит из импульса, а импульс формируется за два такта
//==============================================================================
// Расстояние от оси колеса до гироприбора 225мм - потребуется для расчета пройденного до выпрямления расстояния
//==============================================================================
// Следует учесть, что чем ниже центр масс робота тем меньше момент инерции, тем быстрее нужно компенсировать наклон
// В то время, как чем выше центр масс тем дальше расстояние, которое нужно пройти роботу, чтобы компенсировать угол наклона...

const double _1_d_131 = 1.0 * DEG_TO_RAD / 131.0;
double Acsel = 0;
double Gyro = 0;

double Speed = 0;
double max_dSpeed = 60; //Максимальное изменение скорости/секунду (шагов в секунду)
double  maxSpeed = 3000; //Шагов в секунду
double Move = 0; //Пройденный путь.
double OldSpeed = 0;
double Acsel_other_side = 0;

double Kp, Kd, Ki; //Коэффициенты

unsigned long t_period;
double CommandSpeed = 0; //Скорость управляемого движения.
double OldCommandSpeed = 0; //Скорость управляемого движения из предыдущего опроса
double Turn = 0; //Поворот.
double TurnOld = 0; // Поворот из прошлой итерации.
double  SpeedR = 0;
double  SpeedL = 0;
double dSpeed = 0; //Ускорение на робота
double dSpeedL = 0; //Ускорение на колесо
double dSpeedR = 0; //Ускорение на колесо

double MoveStab = 0;
bool flag_crash = true;
bool flag_time_standup = true;// Флаг того, что робот встает.
unsigned long time_standup = 0; // Время на подъем робота
double XSpeed = 0; //Реальная скорость по шагам в моторах
double XSpeedL = 0; //Реальная скорость по шагам в моторах
double XSpeedR = 0; //Реальная скорость по шагам в моторах
double  OldXSpeed = 0; //Реальная скорость по шагам в моторах
double  OldXSpeedL = 0; //Реальная скорость по шагам в моторах
double  OldXSpeedR = 0; //Реальная скорость по шагам в моторах
//Нужно его использовать
bool flag_to_off_robot  = false; //Флаг выключения робота
long time_to_off_robot = 0; //Время наприсадку робота
